Program Turok1Ch;
{$APPTYPE CONSOLE}

Const
  // actually there is only 16 characters - last one for not implemented "pen and ink" cheat
  code_chars: array[0..16] of char = 'BCDFGHJKLMNPQRST?'; //'bcdfghjklmnpqrst?';

Type
  TCheats = Packed Record
    name_offs: Longword; // string like "invincibility" or "spirit mode"
    code_size: Longword; // length of cheat
    code_offs: Longword; // cheat offset
    code_unkn: Longword; // unknown
  End;

Var
  I, J, COffs, CBase: Longword;
                  CR: TCheats;
                  Fl: File;
                   S: String;

// for N64 version only
{function swap32(a: longword): longword; assembler;
asm
  bswap eax
end;}

Begin
  WriteLn('Turok: Dinosaur Hunter cheats decoder');
  WriteLn('(c) -=CHE@TER=- 2010,2022');
  WriteLn('http://ctpax-cheater.losthost.org/htmldocs/turok.htm');
  WriteLn;
  AssignFile(Fl, 'Turok.exe');
  {$I-}
  FileMode:=0;
  Reset(Fl, 1);
  FileMode:=2;
  {$I+}

  If IOResult <> 0 Then
  Begin
    WriteLn('Game executable file "Turok.exe" not found!');
    Exit;
  End;

{
  TurokDemo.exe (Demo v1.01)
  Turok Build: Dec 19 1997  17:02:34

  COffs:=$10B7E0;
  CBase:=$401600;

  All cheats the same as in D3D version
}

  If FileSize(Fl) = 1088000 Then // 3Dfx version
  Begin
    COffs:=$09C200;
    CBase:=$400A00;
  End
  Else // D3D version
  Begin
    COffs:=$1080B8;
    CBase:=$401000;
  End;
  // for N64 version only
  {COffs:=$C2EDF3;
  CBase:=$C2ECAB;}

  For I:=0 To 28 Do
  Begin
    Seek(Fl, COffs + SizeOf(CR)*I);
    BlockRead(Fl, CR, SizeOf(CR));
    // for N64 version only
    {CR.code_offs:=swap32(CR.code_offs) - $800B8110;
    CR.code_size:=swap32(CR.code_size);}

    Seek(Fl, CR.code_offs - CBase);
    SetLength(S, CR.code_size);
    BlockRead(Fl, S[1], CR.code_size);

    For J:=1 To CR.code_size Do
      If (S[J] >= #0) And (S[J] <= #16) Then
        S[J]:=code_chars[Ord(S[J])]
      Else
        S[J]:='#';

    WriteLn(S);

    // not implemented "pen and ink" cheat - write file offset for first char
    // useful if you want to replace it with right one and try this cheat out
//    If S[1] = '?' Then WriteLn('> ', CR.code_offs - CBase);
  End;

  CloseFile(Fl);
End.
